import { login, logout, getInfo, refreshToken, checkCode, loginByMall } from '@/api/login'
import { getToken, setToken, setExpiresIn, removeToken } from '@/utils/auth'
import { Notification, MessageBox, Message, Loading } from 'element-ui'
import { encrypt } from '@/utils/jsencrypt'

const user = {
  state: {
    token: getToken(),
    id: '',
    name: '',
    avatar: '',
    roles: [],
    permissions: []
  },

  mutations: {
    SET_TOKEN: (state, token) => {
      state.token = token
    },
    SET_EXPIRES_IN: (state, time) => {
      state.expires_in = time
    },
    SET_ID: (state, id) => {
      state.id = id
    },
    SET_NAME: (state, name) => {
      state.name = name
    },
    SET_AVATAR: (state, avatar) => {
      state.avatar = avatar
    },
    SET_ROLES: (state, roles) => {
      state.roles = roles
    },
    SET_PERMISSIONS: (state, permissions) => {
      state.permissions = permissions
    }
  },

  actions: {
    // 登录
    async Login({ commit }, userInfo) {
      const username = userInfo.username.trim()
      const password = encrypt(userInfo.password)
      // const password = userInfo.password
      const code = userInfo.code
      const uuid = userInfo.uuid
      const textCode = userInfo.textCode

      console.log(userInfo.textCode, userInfo, '******************')
      // const textCode = undefined
      // if (userInfo.textCode) {
      //   textCode = userInfo.textCode
      // }
      return new Promise((resolve, reject) => {
        login(username, password, code, uuid, textCode).then(res => {
          let data = res.data
          localStorage.setItem('isCode', res.data.code || '')
          setToken(data.access_token)
          commit('SET_TOKEN', data.access_token)
          localStorage.setItem('token', data.access_token)
          setExpiresIn(data.expires_in)
          commit('SET_EXPIRES_IN', data.expires_in)
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },
    // 短信验证码 登录
    textLogin({ commit }, userInfo) {
      console.log(userInfo)
      let params = {
        phone: userInfo.phone,
        code: userInfo.textCode
      }
      return new Promise((resolve, reject) => {
        checkCode(params).then(res => {
          console.log(res)
          if (res.code == 200) {
            let data = res.data
            setToken(data.access_token)
            commit('SET_TOKEN', data.access_token)
            localStorage.setItem('token', data.access_token)
            setExpiresIn(data.expires_in)
            commit('SET_EXPIRES_IN', data.expires_in)
            resolve()
          }
        }).catch(error => {
          reject(error)
        })
      })
    },
    //机具租赁平台跳转登录---南网
    ssoLogin({ commit }, param) {
      return new Promise((resolve, reject) => {
        loginByMall(param).then(res => {
          console.log(res)
          let data = res.data
          if (res.code == 200) {
            // console.log('登录成功1111111')
            setToken(data.access_token)
            commit('SET_TOKEN', data.access_token)
            localStorage.setItem('token', data.access_token)
            setExpiresIn(data.expires_in)
            commit('SET_EXPIRES_IN', data.expires_in)
          } else {
            // console.log('登录失败22222222')
            this.$modal.msgError('登录失败');
          }
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },


    // 获取用户信息
    GetInfo({ commit, state }) {
      return new Promise((resolve, reject) => {
        getInfo().then(res => {
          const user = res.user
          /* 存储当前登录用户的userId */
          sessionStorage.setItem('userId', user.userId)
          sessionStorage.setItem('deptId', user.deptId)
          const avatar = (user.avatar == "" || user.avatar == null) ? require("@/assets/images/profile.jpg") : user.avatar;
          if (res.roles && res.roles.length > 0) { // 验证返回的roles是否是一个非空数组
            commit('SET_ROLES', res.roles)
            commit('SET_PERMISSIONS', res.permissions)
          } else {
            commit('SET_ROLES', ['ROLE_DEFAULT'])
          }
          commit('SET_ID', user.userId)
          commit('SET_NAME', user.userName)
          commit('SET_AVATAR', avatar)
          resolve(res)
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 刷新token
    RefreshToken({ commit, state }) {
      return new Promise((resolve, reject) => {
        refreshToken(state.token).then(res => {
          setExpiresIn(res.data)
          commit('SET_EXPIRES_IN', res.data)
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 退出系统
    LogOut({ commit, state }) {
      return new Promise((resolve, reject) => {
        logout(state.token).then(() => {
          commit('SET_TOKEN', '')
          commit('SET_ROLES', [])
          commit('SET_PERMISSIONS', [])
          localStorage.removeItem('isCode')
          removeToken()
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 前端 登出
    FedLogOut({ commit }) {
      return new Promise(resolve => {
        commit('SET_TOKEN', '')
        removeToken()
        resolve()
      })
    }
  }
}

export default user
